<template>
  <v-main class="main-style">
    <v-card class="mb-3 bg-blue-darken-4">
      <div class="d-flex justify-space-between align-center">
        <h2 class="m-3">Tickets</h2>
        <create-ticket-dialog
            :page="currentPage"
        ></create-ticket-dialog>
      </div>
    </v-card>

    <v-card>
      <table class="table table-bordered table-hover text-center" v-if="!showComponent">
        <thead>
        <tr>
          <th>ID</th>
          <th>Titel</th>
          <th>Beschreibung</th>
          <th>Erstellt</th>
          <th>Priorität</th>
          <th>Status</th>
          <th>Abteilung</th>
          <th>Aktionen</th>
        </tr>
        </thead>

        <tbody>
        <ticket-data
            v-for="ticket in tickets"
            :ticket="ticket"
            :page="currentPage"
            @show-component="handleShowComponent"
        >
        </ticket-data>
        </tbody>
        <tr>
          <td colspan="1">
            <v-btn
                color="blue-darken-4"
                @click="prevPage"
                :disabled="currentPage === 1"><v-icon>mdi-arrow-left-drop-circle-outline</v-icon></v-btn>
          </td>
          <td colspan="6">
            <p class="border-light-subtle mt-2 text-center">Seite: {{currentPage}}</p>
          </td>
          <td colspan="1">
            <v-btn
                color="blue-darken-4"
                :disabled="tickets.length < 20"
                @click="nextPage"><v-icon>mdi-arrow-right-drop-circle-outline</v-icon></v-btn>
          </td>
        </tr>
      </table>
    </v-card>


    <h2 v-if="showComponent">hallo</h2>
    <v-card v-if="showComponent">
      <single-ticket-view
          @show-component="handleShowComponent"
          :ticketId="receivedTicketId"
          :page="currentPage"
      ></single-ticket-view>
    </v-card>
  </v-main>

</template>

<script setup>
import TicketData from "@/components/TicketData.vue";
import {useTicketStore} from "@/stores/ticketStore";
import {computed, onMounted, ref} from "vue";
import CreateTicketDialog from "@/components/dialogs/CreateTicketDialog.vue";
import SingleTicketView from "@/views/SingleTicketView.vue";

const ticketStore = useTicketStore();
const tickets = computed(() => {
  return ticketStore.tickets.filter(ticket => ticket.ticketStatus !== 'RESOLVED')
      .sort((a, b) => {
        const priorityValues = {
          'VERY_IMPORTANT': 4,
          'IMPORTANT': 3,
          'MODERATE': 2,
          'LESS_IMPORTANT': 1,
        };

        return priorityValues[b.priority] - priorityValues[a.priority];
      });
});
const currentPage = ref(1);
const showComponent = ref(false)
const receivedTicketId = ref(null);

function handleShowComponent(ticketId) {
  receivedTicketId.value = ticketId;
  showComponent.value = !showComponent.value
}

async function fetchTickets(page) {
  await ticketStore.getTickets(page);
}

onMounted(async () => {
  await fetchTickets(currentPage.value)
})

function nextPage() {
  currentPage.value++;
  fetchTickets(currentPage.value);
}

function prevPage() {
  if (currentPage.value > 0) {
    currentPage.value--;
    fetchTickets(currentPage.value);
  }
}

</script>

<style scoped>
.main-style {
  min-height: 95vh;
}

</style>